/* 
  Тестировалось на Arduino IDE 1.6.12
  Дата тестирования 16.12.2016г.
*/
#include <Wire.h>                                                              // Подключаем библиотеку
#include <LiquidCrystal_I2C.h>                                                 // Подключаем библиотеку

LiquidCrystal_I2C lcd(0x27,16,2);                                              // Задаем адрес и размер дисплея

#define moneyPin 2                                                             // Вывод Pulse
#define InhiBit 3                                                              // Вывод InhiBit (сигнал запрета)

int valuePulse = 10;                                                           // Стоимость одного импульса
int minWidthPulse = 40;                                                        // Минимальная ширина одного импульса
int maxWidthPulse = 60;                                                        // Максимальная ширина одного импульса
int debounce = 4;                                                              // Защита от помех
int pulseCount = 0;                                                            // Сколько импульсов получено
int receivedRUB = 0;                                                           // Перемення для хранения суммы
unsigned long pulseDuration;                                                   // Как давно был последний импульс
unsigned long pulseBegin = 0;                                                  // Начало импульса
unsigned long pulseEnd = 0;                                                    // Конец импульса
unsigned long curtime;                                                         // Время
int postPulsePause = 300;                                                      // Время ожидания, для заверщения подсчета импульсов
int pulseState;                                                                // Состояние входа "0" или "1"
int lastState = 1;                                                             // Последнние состояние входа "0" или "1" 

void setup() 
{
  pinMode(moneyPin, INPUT);                                                    // Установить вывод moneyPin как вход
  pinMode(InhiBit, OUTPUT);                                                    // Установить вывод InhiBit как выход
  digitalWrite(InhiBit,HIGH);                                                  // Установить на InhiBit лог "1"
  Serial.begin(9600);                                                          // Включаем последовательный порт, на скорости 9600
  lcd.init();                                                                  // Инициализация LCD
  lcd.backlight();                                                             // Включаем подсветку
  lcd.setCursor(0,0);                                                          // Устанавливаем курсор в начачло первой строки
  lcd.print("NO MONEY ");                                                      // Вывести текст на LCD
}
void loop() 

{
   pulseState = digitalRead(moneyPin);                                         // Считываем значение с входа moneyPin
   curtime = millis();                                                         // Записываем значение миллисекунд с момента начала выполнения программы
   
  if ((pulseState == 0) && (lastState == 1))                                   // Ждем начало импула, логический "0"
    {             
     pulseBegin = curtime;                                                     // Записываем значение милисикунд
     lastState = 0;                                                            // Записываем значение "0" в переменную lastState
    } 
  else if ((pulseState == 1) && (lastState == 0))                              // Ждем окончания импула, логический "1"
    { 
     pulseDuration = curtime - pulseBegin;                                     // Расчет длительности импульса в миллисекунд
       if (pulseDuration > debounce)                                           // Защита от помех, если импульс был небольшой 
         { 
          lastState = 1;                                                       // Записываем значение "1" в переменную lastState
         }
       if ((pulseDuration > minWidthPulse) && (pulseDuration < maxWidthPulse)) // Провиряем ширину импульса 
         { 
          pulseEnd = curtime;                                                  // Сохранить значнеие милисикунд, окончания импульса
          pulseCount++;                                                        // Инкремент счетчика импульсов
         }
    }  
       if ((pulseEnd > 0) && (curtime - pulseEnd > postPulsePause))            // Проверяем, поступают ли еще импульсы
         { 
          receivedRUB += pulseCount * valuePulse;                              // Расчет суммы
          
          lcd.setCursor(0,0);                                                  // Устанавливаем курсор в начачло первой строки
          lcd.clear();                                                         // Очистка дисплея
          lcd.print("Credit: ");                                               // Вывести текст на LCD
          lcd.setCursor(0,1);                                                  // Устанавливаем курсор в начачло второй строки
          lcd.print(receivedRUB);                                              // Вывести значение переменной на LCD
          lcd.print(" RUB");                                                   // Вывести значение переменной на LCD
          Serial.print("Credit: ");                                            // Вывести текст на последовательный порт
          Serial.print(receivedRUB);                                           // Вывести значение переменной на пслеовательный порт
          Serial.println(" RUB");                                              // Вывести текст на последовательный порт
          pulseEnd = 0;                                                        // Обнуляем пеерменную
          pulseCount = 0;                                                      // Обнуляем пеерменную
          receivedRUB = 0;                                                     // Обнуляем пеерменную
         }
}
